const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const revision_approvals = sequelize.define(
    'revision_approvals',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

decision: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"approved",


"rejected"

        ],

      },

decided_at: {
        type: DataTypes.DATE,
      
      

      },

comment: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  revision_approvals.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.revision_approvals.belongsTo(db.document_revisions, {
      as: 'document_revision',
      foreignKey: {
        name: 'document_revisionId',
      },
      constraints: false,
    });

    db.revision_approvals.belongsTo(db.contract_participants, {
      as: 'contract_participant',
      foreignKey: {
        name: 'contract_participantId',
      },
      constraints: false,
    });

    db.revision_approvals.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.revision_approvals.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.revision_approvals.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return revision_approvals;
};


